'use strict';

var spawnify = require('spawnify/legacy');

module.exports = function (callback) {
    var CMD = 'dscl . -list /Users UniqueID | sort -nk 2';
    var spawn = spawnify(CMD);
    
    spawn.on('error', function (error) {
        callback(error);
    });
    
    var dataAll = '';
    
    spawn.on('data', function (data) {
        dataAll += data;
    });
    
    spawn.on('close', function () {
        callback(null, parse(dataAll));
    });
};

module.exports.parse = parse;

function parse(dataAll) {
    var users = {};
    
    dataAll
        .split('\n')
        .forEach(function (item) {
            var data = item.split(' ');
            var n = data.length - 1;
            var id = data[n];
            var name = data[0];
            
            if (!id)
                { return; }
            
            users[id] = name;
        });
    
    return users;
}

